getFinalCMFM<-function(V_mR,V_miR,newCMFM){
  # neighbour list of module
  neiborlist<-getMiRNANeibor(V_mR,V_miR,C,newCMFM)
  
  # final CMFM 
  finalCMFM<-addMiRNA(V_mR,V_miR,newCMFM,neiborlist,C)
  
  finalCMFM
}

getClvmir<-function(V_miR){
  clvmir<-c()  #miRNA-mRNA regulation
  #calculate edge number
  for(i in 1:length(V_miR)){
    clvmir<-c(clvmir,length(V_miR[[i]])*length(V_mR[[i]]))
  }
  clvmir
}

getMiRNANeibor<-function(V_mR,V_miR,C,newCMFM){
  idensmodule<-newCMFM$module
  neiborlist<-c()

  for(i in 1:length(idensmodule)){
    #get a original module
    vmR<-V_mR[[idensmodule[i]]]
    neibor<-c()
    for(j in 1:length(vmR)){
      #miRNA neighbour nodes of a mRNA
      mneibor<-which(C[as.integer(vmR[j]),]>0)
      neibor<-union(neibor,mneibor)
    }
    neibor<-setdiff(neibor,V_miR[i])
    neiborlist<-c(neiborlist,list(neibor))
  }
  neiborlist
}


addMiRNA<-function(V_mR,V_miR,newCMFM,neiborlist,C,theta=0.5){
  idensmodule<-newCMFM$module
  clvmir<-newCMFM$regNum
  clvmr<-newCMFM$ppiNum
  cdens_vmir<-newCMFM$regDens
  cdens_vmr<-newCMFM$ppiDens
  
  for(i in 1:length(idensmodule)){
    imodule<-as.integer(idensmodule[i])

    vmiR<-V_miR[[imodule]]
    vmR<-V_mR[[imodule]]
    
    #miRNA number
    vlength<-length(vmiR)
    #edge number
    oldlen<-clvmir[imodule]
    
    mneibor<-neiborlist[[i]]
    for(j in 1:length(mneibor)){
      #get a neighbour mirna
      mirna<-as.integer(mneibor[j])
      
      #calculate regulation density R_density
      nmirna<-length(V_miR[[imodule]])+1
      nmrna<-length(V_mR[[imodule]])
      
     
      tmR<-which(C[,mirna]>0)
      #calculate new miRNA-mRNA edge number
      newedge<-length(intersect(tmR,V_mR[[imodule]]))
      midens<-(clvmir[imodule]+newedge)/(nmirna*nmrna)
      #more than the old one
      if(midens>theta){
        #update edge number
        clvmir[imodule]<-clvmir[imodule]+newedge
        #update density
        cdens_vmir[imodule]<-midens
        #update mRNA set
        V_miR[[imodule]]<-union(V_miR[[imodule]],mirna)
      }
    }
    
  }
  resultMatrix<-matrix(c(idensmodule,V_miR[idensmodule],clvmir[idensmodule],V_mR[idensmodule], clvmr[idensmodule], cdens_vmir[idensmodule], cdens_vmr[idensmodule]),byrow = F,ncol=7)
  colnames(resultMatrix)<-c("module","miRNA","regNum","mRNA","ppiNum","regDens","ppiDens")
  resultMatrix<-resultMatrix[which(resultMatrix[,"ppiNum"]>1),]
}
